source: git/.github/workflows/ci-sage.yml @ 8299b7

spielwiese
Last change on this file since 8299b7 was d737325, checked in by Matthias Koeppe <mkoeppe@…>, 3 years ago
.github/workflows/ci-sage.yml: Do not use qepcad (broken on cygwin)
  • Property mode set to 100644
File size: 20.5 KB
Line 
1name: Run Sage CI for Linux/Cygwin/macOS
2
3## This GitHub Actions workflow provides:
4##
5##  - portability testing, by building and testing this project on many platforms
6##    (Linux variants and Cygwin), each with two configurations (installed packages),
7##
8##  - continuous integration, by building and testing other software
9##    that depends on this project.
10##
11## It runs on every pull request and push of a tag to the GitHub repository.
12##
13## The testing can be monitored in the "Actions" tab of the GitHub repository.
14##
15## After all jobs have finished (or are canceled) and a short delay,
16## tar files of all logs are made available as "build artifacts".
17##
18## This GitHub Actions workflow uses the portability testing framework
19## of SageMath (https://www.sagemath.org/).  For more information, see
20## https://doc.sagemath.org/html/en/developer/portability_testing.html
21
22## The workflow consists of two jobs:
23##
24##  - First, it builds a source distribution of the project
25##    and generates a script "update-pkgs.sh".  It uploads them
26##    as a build artifact named upstream.
27##
28##  - Second, it checks out a copy of the SageMath source tree.
29##    It downloads the upstream artifact and replaces the project's
30##    package in the SageMath distribution by the newly packaged one
31##    from the upstream artifact, by running the script "update-pkgs.sh".
32##    Then it builds a small portion of the Sage distribution.
33##
34## Many copies of the second step are run in parallel for each of the tested
35## systems/configurations.
36
37#on: [push, pull_request]
38
39on:
40  pull_request:
41    types: [opened, synchronize]
42  push:
43    tags:
44      - '*'
45  workflow_dispatch:
46    # Allow to run manually
47
48env:
49  # Ubuntu packages to install so that the project's "make dist" can succeed
50  DIST_PREREQ: libcdd-dev
51  # Name of this project in the Sage distribution
52  SPKG:        singular
53  # Sage distribution packages to build
54  TARGETS_PRE: build/make/Makefile
55  TARGETS:     SAGE_CHECK=no SAGE_CHECK_PACKAGES=singular,pynac singular pynac
56  TARGETS_OPTIONAL: SAGE_CHECK=no SAGE_CHECK_pysingular=warn pysingular
57  # Standard setting: Test the current beta release of Sage:
58  SAGE_REPO:   sagemath/sage
59  SAGE_REF:    develop
60  # Temporarily test with the branch from a sage ticket with build script fixes
61  # (this is a no-op after that ticket is merged)
62  SAGE_TRAC_GIT: https://github.com/sagemath/sagetrac-mirror.git
63  SAGE_TICKET: 31642
64  REMOVE_PATCHES: "*"
65
66jobs:
67
68  dist:
69    runs-on: ubuntu-latest
70    steps:
71      - name: Check out ${{ env.SPKG }}
72        uses: actions/checkout@v2
73        with:
74          path: build/pkgs/${{ env.SPKG }}/src
75      - name: Install prerequisites
76        run: |
77          sudo DEBIAN_FRONTEND=noninteractive apt-get update
78          sudo DEBIAN_FRONTEND=noninteractive apt-get install $DIST_PREREQ
79      - name: Run make dist, prepare upstream artifact
80        run: |
81          (cd build/pkgs/${{ env.SPKG }}/src && (./autogen.sh && ./configure && make dist) ) \
82          && mkdir -p upstream && cp build/pkgs/${{ env.SPKG }}/src/*.tar.gz upstream/${{ env.SPKG }}-git.tar.gz \
83          && echo "sage-package create ${{ env.SPKG }} --version git --tarball ${{ env.SPKG }}-git.tar.gz --type=optional" > upstream/update-pkgs.sh \
84          && if [ -n "${{ env.REMOVE_PATCHES }}" ]; then echo "(cd ../build/pkgs/${{ env.SPKG }}/patches && rm -f ${{ env.REMOVE_PATCHES }}; :)" >> upstream/update-pkgs.sh; fi \
85          && echo 'echo ntl flint readline mpfr cddlib 4ti2 > ../build/pkgs/singular/dependencies' >> upstream/update-pkgs.sh \
86          && ls -l upstream/
87      - uses: actions/upload-artifact@v2
88        with:
89          path: upstream
90          name: upstream
91
92  kanarienvogel:
93    # Quick run for 1 platform first; do not run the other platforms when this already fails
94    runs-on: ubuntu-latest
95    needs: [dist]
96    strategy:
97      fail-fast: true
98      max-parallel: 4
99      matrix:
100        tox_system_factor: [ubuntu-focal]
101        tox_packages_factor: [standard]
102    env:
103      # Override so that this runs faster
104      TARGETS: SAGE_CHECK=no singular
105      TARGETS_OPTIONAL: build/make/Makefile
106    # The rest of this is identical to job "docker":
107      TOX_ENV: docker-${{ matrix.tox_system_factor }}-${{ matrix.tox_packages_factor }}
108      LOGS_ARTIFACT_NAME: logs-commit-${{ github.sha }}-tox-docker-${{ matrix.tox_system_factor }}-${{ matrix.tox_packages_factor }}
109      DOCKER_TARGETS: configured with-targets with-targets-optional
110    steps:
111      - name: Check out SageMath
112        uses: actions/checkout@v2
113        with:
114          repository: ${{ env.SAGE_REPO }}
115          ref: ${{ env.SAGE_REF }}
116          fetch-depth: 2000
117        if: env.SAGE_REPO != ''
118      - name: Check out git-trac-command
119        uses: actions/checkout@v2
120        with:
121          repository: sagemath/git-trac-command
122          path: git-trac-command
123        if: env.SAGE_TRAC_GIT != ''
124      - name: Check out SageMath from trac.sagemath.org
125        shell: bash {0}
126        run: |
127          git config --global user.email "ci-sage@example.com"
128          git config --global user.name "ci-sage workflow"
129          if [ ! -d .git ]; then git init; fi; git remote add trac ${{ env.SAGE_TRAC_GIT }} && x=1 && while [ $x -le 5 ]; do x=$(( $x + 1 )); sleep $(( $RANDOM % 60 + 1 )); if git-trac-command/git-trac fetch $SAGE_TICKET; then git merge FETCH_HEAD || echo "(ignored)"; exit 0; fi; sleep 40; done; exit 1
130        if: env.SAGE_TRAC_GIT != ''
131      - uses: actions/download-artifact@v2
132        with:
133          path: upstream
134          name: upstream
135      - name: Install test prerequisites
136        run: |
137          sudo DEBIAN_FRONTEND=noninteractive apt-get update
138          sudo DEBIAN_FRONTEND=noninteractive apt-get install tox python3-setuptools
139      - name: Update Sage packages from upstream artifact
140        run: |
141          (export PATH=$(pwd)/build/bin:$PATH; (cd upstream && bash -x update-pkgs.sh) && sed -i.bak '/upstream/d' .dockerignore && echo "/:toolchain:/i ADD upstream upstream" | sed -i.bak -f - build/bin/write-dockerfile.sh && git diff)
142      - name: Configure and build Sage distribution within a Docker container
143        run: |
144          set -o pipefail; EXTRA_DOCKER_BUILD_ARGS="--build-arg USE_MAKEFLAGS=\"-k V=0 SAGE_NUM_THREADS=3\"" tox -e $TOX_ENV -- $TARGETS 2>&1 | sed "/^configure: notice:/s|^|::warning file=artifacts/$LOGS_ARTIFACT_NAME/config.log::|;/^configure: warning:/s|^|::warning file=artifacts/$LOGS_ARTIFACT_NAME/config.log::|;/^configure: error:/s|^|::error file=artifacts/$LOGS_ARTIFACT_NAME/config.log::|;"
145      - name: Copy logs from the Docker image or build container
146        run: |
147          mkdir -p "artifacts/$LOGS_ARTIFACT_NAME"
148          cp -r .tox/$TOX_ENV/Dockerfile .tox/$TOX_ENV/log "artifacts/$LOGS_ARTIFACT_NAME"
149          if [ -f .tox/$TOX_ENV/Dockertags ]; then CONTAINERS=$(docker create $(tail -1 .tox/$TOX_ENV/Dockertags) /bin/bash || true); fi
150          if [ -n "$CONTAINERS" ]; then for CONTAINER in $CONTAINERS; do for ARTIFACT in /sage/logs; do docker cp $CONTAINER:$ARTIFACT artifacts/$LOGS_ARTIFACT_NAME && HAVE_LOG=1; done; if [ -n "$HAVE_LOG" ]; then break; fi; done; fi
151        if: always()
152      - uses: actions/upload-artifact@v2
153        with:
154          path: artifacts
155          name: ${{ env.LOGS_ARTIFACT_NAME }}
156        if: always()
157      - name: Print out logs for immediate inspection
158        # and markup the output with GitHub Actions logging commands
159        run: |
160          .github/workflows/scan-logs.sh "artifacts/$LOGS_ARTIFACT_NAME"
161        if: always()
162      - name: Push Docker images
163        run: |
164          if [ -f .tox/$TOX_ENV/Dockertags ]; then
165            TOKEN="${{ secrets.DOCKER_PKG_GITHUB_TOKEN }}"
166            if [ -z "$TOKEN" ]; then
167              TOKEN="${{ secrets.GITHUB_TOKEN }}"
168            fi
169            echo "$TOKEN" | docker login docker.pkg.github.com -u ${{ github.actor }} --password-stdin
170            for a in $(cat .tox/$TOX_ENV/Dockertags); do
171              FULL_TAG=docker.pkg.github.com/$(echo ${{ github.repository }}|tr 'A-Z' 'a-z')/$a
172              docker tag $a $FULL_TAG
173              echo Pushing $FULL_TAG
174              docker push $FULL_TAG
175            done || echo "(Ignoring errors)"
176          fi
177        if: always()
178
179  schwanenfenster:
180    env:
181      STAGE: i-a
182      LOCAL_ARTIFACT_NAME: sage-local-commit-${{ github.sha }}-cygwin-${{ matrix.pkgs }}
183      LOGS_ARTIFACT_NAME: logs-commit-${{ github.sha }}-cygwin-${{ matrix.pkgs }}
184      MAKE: make -j8
185      SAGE_NUM_THREADS: 3
186      SAGE_CHECK: yes
187      SAGE_CHECK_PACKAGES: "!cython,!r,!python3,!python2,!nose,!pathpy,!gap,!cysignals,!linbox,!git,!ppl"
188      CYGWIN: winsymlinks:native
189      CONFIGURE_ARGS: --enable-experimental-packages --enable-download-from-upstream-url
190      SAGE_FAT_BINARY: yes
191      SAGE_LOCAL: /opt/sage-singular-${{ github.sha }}
192
193    runs-on: windows-latest
194
195    needs: [dist]
196
197    strategy:
198      fail-fast: false
199      matrix:
200        pkgs: [minimal, standard]
201    steps:
202    - run: |
203        git config --global core.autocrlf false
204        git config --global core.symlinks true
205    - name: install cygwin with choco
206      shell: bash {0}
207      run: |
208        choco --version
209        choco install git python3 --source cygwin
210    - name: Check out SageMath
211      uses: actions/checkout@v2
212      with:
213        repository: ${{ env.SAGE_REPO }}
214        ref: ${{ env.SAGE_REF }}
215        fetch-depth: 2000
216      if: env.SAGE_REPO != ''
217    - name: Check out git-trac-command
218      uses: actions/checkout@v2
219      with:
220        repository: sagemath/git-trac-command
221        path: git-trac-command
222      if: env.SAGE_TRAC_GIT != ''
223    - name: Check out SageMath from trac.sagemath.org
224      shell: bash {0}
225      # Random sleep and retry to limit the load on trac.sagemath.org
226      run: |
227        git config --global user.email "ci-sage@example.com"
228        git config --global user.name "ci-sage workflow"
229        if [ ! -d .git ]; then git init; fi; git remote add trac ${{ env.SAGE_TRAC_GIT }} && x=1 && while [ $x -le 5 ]; do x=$(( $x + 1 )); sleep $(( $RANDOM % 60 + 1 )); if git-trac-command/git-trac fetch $SAGE_TICKET; then git merge FETCH_HEAD || echo "(ignored)"; exit 0; fi; sleep 40; done; exit 1
230      if: env.SAGE_TRAC_GIT != ''
231    - uses: actions/download-artifact@v2
232      with:
233        path: upstream
234        name: upstream
235    - name: install minimal prerequisites with choco
236      shell: bash {0}
237      run: |
238        choco --version
239        PACKAGES="python38 python38-pip"
240        choco install $PACKAGES --source cygwin
241    - name: Update Sage packages from upstream artifact
242      run: |
243        C:\\tools\\cygwin\\bin\\bash -l -c 'cd $(cygpath -u "$GITHUB_WORKSPACE") && ls -l upstream/ && export PATH="$(pwd)/build/bin:$PATH:/usr/local/bin:/usr/bin" && (cd upstream && bash -x update-pkgs.sh) && git diff'
244    - name: tox
245      run: |
246        C:\\tools\\cygwin\\bin\\bash -l -x -c 'python3.8 -m pip install tox'
247        C:\\tools\\cygwin\\bin\\bash -l -x -c 'cd $(cygpath -u "$GITHUB_WORKSPACE") && PREFIX="${{ env.SAGE_LOCAL }}" tox -e local-cygwin-choco-${{ matrix.pkgs }} -- $TARGETS'
248    - name: Prepare logs artifact
249      shell: bash
250      run: |
251        mkdir -p "artifacts/$LOGS_ARTIFACT_NAME"; for a in local/var/tmp/sage/build/*; do if [ -d $a ]; then tar -c --remove-files -f "artifacts/$LOGS_ARTIFACT_NAME/$(basename $a).tar" $a || tar -c --ignore-failed-read -f "artifacts/$LOGS_ARTIFACT_NAME/$(basename $a)-save.tar" $a ; fi; done; cp -r logs/*  "artifacts/$LOGS_ARTIFACT_NAME"
252      if: always()
253    - uses: actions/upload-artifact@v2
254      with:
255        path: artifacts
256        name: ${{ env.LOGS_ARTIFACT_NAME }}
257      if: always()
258    - name: Print out logs for immediate inspection
259      # The markup in the output is a GitHub Actions logging command
260      # https://help.github.com/en/actions/automating-your-workflow-with-github-actions/development-tools-for-github-actions
261      shell: bash
262      run: |
263        find "artifacts/$LOGS_ARTIFACT_NAME" -type f -name "*.log" -exec sh -c 'if tail -20 "{}" 2>/dev/null | grep "^Error" >/dev/null; then echo :":"error file={}:":" ==== LOG FILE {} CONTAINS AN ERROR ====; cat {} ; fi' \;
264      if: always()
265    - name: Prepare sage-local artifact
266      # We specifically use the cygwin tar so that symlinks are saved/restored correctly on Windows.
267      # We remove the $SAGE_LOCAL/lib64 link, which will be recreated by the next stage.
268      run: |
269        C:\\tools\\cygwin\\bin\\bash -l -c 'cd $(cygpath -u "$GITHUB_WORKSPACE") && rm -f "${{ env.SAGE_LOCAL }}"/lib64; tar -cf /tmp/sage-local-${{ env.STAGE }}.tar --remove-files "${{ env.SAGE_LOCAL }}"'
270      if: always()
271    - uses: actions/upload-artifact@v2
272      # upload-artifact@v2 does not support whitespace in file names.
273      # so we tar up the directory ourselves
274      with:
275        path: C:\\tools\\cygwin\\tmp\\sage-local-${{ env.STAGE }}.tar
276        name: ${{ env.LOCAL_ARTIFACT_NAME }}
277      if: always()
278
279  docker:
280    runs-on: ubuntu-latest
281    needs: [dist, kanarienvogel]
282    strategy:
283      fail-fast: false
284      max-parallel: 32
285      matrix:
286        tox_system_factor: [ubuntu-trusty, ubuntu-xenial, ubuntu-bionic, ubuntu-focal, ubuntu-groovy, ubuntu-hirsute, debian-jessie, debian-stretch, debian-buster, debian-bullseye, debian-sid, linuxmint-17, linuxmint-18, linuxmint-19, linuxmint-19.3, linuxmint-20.1, fedora-26, fedora-27, fedora-28, fedora-29, fedora-30, fedora-31, fedora-32, fedora-33, fedora-34, centos-7, centos-8, gentoo, archlinux-latest, slackware-14.2, conda-forge, ubuntu-bionic-i386, ubuntu-focal-i386, debian-buster-i386, centos-7-i386, raspbian-buster-armhf]
287        tox_packages_factor: [minimal, standard]
288    env:
289      TOX_ENV: docker-${{ matrix.tox_system_factor }}-${{ matrix.tox_packages_factor }}
290      LOGS_ARTIFACT_NAME: logs-commit-${{ github.sha }}-tox-docker-${{ matrix.tox_system_factor }}-${{ matrix.tox_packages_factor }}
291      DOCKER_TARGETS: configured with-targets with-targets-optional
292    steps:
293      - name: Check out SageMath
294        uses: actions/checkout@v2
295        with:
296          repository: ${{ env.SAGE_REPO }}
297          ref: ${{ env.SAGE_REF }}
298          fetch-depth: 2000
299        if: env.SAGE_REPO != ''
300      - name: Check out git-trac-command
301        uses: actions/checkout@v2
302        with:
303          repository: sagemath/git-trac-command
304          path: git-trac-command
305        if: env.SAGE_TRAC_GIT != ''
306      - name: Check out SageMath from trac.sagemath.org
307        shell: bash {0}
308        run: |
309          git config --global user.email "ci-sage@example.com"
310          git config --global user.name "ci-sage workflow"
311          if [ ! -d .git ]; then git init; fi; git remote add trac ${{ env.SAGE_TRAC_GIT }} && x=1 && while [ $x -le 5 ]; do x=$(( $x + 1 )); sleep $(( $RANDOM % 60 + 1 )); if git-trac-command/git-trac fetch $SAGE_TICKET; then git merge FETCH_HEAD || echo "(ignored)"; exit 0; fi; sleep 40; done; exit 1
312        if: env.SAGE_TRAC_GIT != ''
313      - uses: actions/download-artifact@v2
314        with:
315          path: upstream
316          name: upstream
317      - name: Install test prerequisites
318        run: |
319          sudo DEBIAN_FRONTEND=noninteractive apt-get update
320          sudo DEBIAN_FRONTEND=noninteractive apt-get install tox python3-setuptools
321      - name: Update Sage packages from upstream artifact
322        run: |
323          (export PATH=$(pwd)/build/bin:$PATH; (cd upstream && bash -x update-pkgs.sh) && sed -i.bak '/upstream/d' .dockerignore && echo "/:toolchain:/i ADD upstream upstream" | sed -i.bak -f - build/bin/write-dockerfile.sh && git diff)
324      - name: Configure and build Sage distribution within a Docker container
325        run: |
326          set -o pipefail; EXTRA_DOCKER_BUILD_ARGS="--build-arg USE_MAKEFLAGS=\"-k V=0 SAGE_NUM_THREADS=3\"" tox -e $TOX_ENV -- $TARGETS 2>&1 | sed "/^configure: notice:/s|^|::warning file=artifacts/$LOGS_ARTIFACT_NAME/config.log::|;/^configure: warning:/s|^|::warning file=artifacts/$LOGS_ARTIFACT_NAME/config.log::|;/^configure: error:/s|^|::error file=artifacts/$LOGS_ARTIFACT_NAME/config.log::|;"
327      - name: Copy logs from the Docker image or build container
328        run: |
329          mkdir -p "artifacts/$LOGS_ARTIFACT_NAME"
330          cp -r .tox/$TOX_ENV/Dockerfile .tox/$TOX_ENV/log "artifacts/$LOGS_ARTIFACT_NAME"
331          if [ -f .tox/$TOX_ENV/Dockertags ]; then CONTAINERS=$(docker create $(tail -1 .tox/$TOX_ENV/Dockertags) /bin/bash || true); fi
332          if [ -n "$CONTAINERS" ]; then for CONTAINER in $CONTAINERS; do for ARTIFACT in /sage/logs; do docker cp $CONTAINER:$ARTIFACT artifacts/$LOGS_ARTIFACT_NAME && HAVE_LOG=1; done; if [ -n "$HAVE_LOG" ]; then break; fi; done; fi
333        if: always()
334      - uses: actions/upload-artifact@v2
335        with:
336          path: artifacts
337          name: ${{ env.LOGS_ARTIFACT_NAME }}
338        if: always()
339      - name: Print out logs for immediate inspection
340        # and markup the output with GitHub Actions logging commands
341        run: |
342          .github/workflows/scan-logs.sh "artifacts/$LOGS_ARTIFACT_NAME"
343        if: always()
344      - name: Push Docker images
345        run: |
346          if [ -f .tox/$TOX_ENV/Dockertags ]; then
347            TOKEN="${{ secrets.DOCKER_PKG_GITHUB_TOKEN }}"
348            if [ -z "$TOKEN" ]; then
349              TOKEN="${{ secrets.GITHUB_TOKEN }}"
350            fi
351            echo "$TOKEN" | docker login docker.pkg.github.com -u ${{ github.actor }} --password-stdin
352            for a in $(cat .tox/$TOX_ENV/Dockertags); do
353              FULL_TAG=docker.pkg.github.com/$(echo ${{ github.repository }}|tr 'A-Z' 'a-z')/$a
354              docker tag $a $FULL_TAG
355              echo Pushing $FULL_TAG
356              docker push $FULL_TAG
357            done || echo "(Ignoring errors)"
358          fi
359        if: always()
360
361  macos:
362
363    runs-on: macos-latest
364    strategy:
365      fail-fast: false
366      max-parallel: 4
367      matrix:
368        os: [ macos-10.15, macos-11.0 ]
369        tox_system_factor: [homebrew-macos, conda-forge-macos]
370        tox_packages_factor: [minimal, standard]
371        xcode_version_factor: [11.7, default]
372
373    needs: [dist, kanarienvogel]
374
375    env:
376      TOX_ENV: local-${{ matrix.tox_system_factor }}-${{ matrix.tox_packages_factor }}
377      LOGS_ARTIFACT_NAME: logs-commit-${{ github.sha }}-tox-local-${{ matrix.tox_system_factor }}-${{ matrix.tox_packages_factor }}-${{ matrix.os }}-xcode_${{ matrix.xcode_version_factor }}
378      DOCKER_TARGETS: configured with-targets with-targets-optional
379
380    steps:
381
382      - name: Select Xcode version
383        run: |
384          if [ ${{ matrix.xcode_version_factor }} != default ]; then sudo xcode-select -s /Applications/Xcode_${{ matrix.xcode_version_factor }}.app; fi
385      - name: Check out SageMath
386        uses: actions/checkout@v2
387        with:
388          repository: ${{ env.SAGE_REPO }}
389          ref: ${{ env.SAGE_REF }}
390          fetch-depth: 2000
391        if: env.SAGE_REPO != ''
392      - name: Check out git-trac-command
393        uses: actions/checkout@v2
394        with:
395          repository: sagemath/git-trac-command
396          path: git-trac-command
397        if: env.SAGE_TRAC_GIT != ''
398      - name: Check out SageMath from trac.sagemath.org
399        shell: bash {0}
400        run: |
401          git config --global user.email "ci-sage@example.com"
402          git config --global user.name "ci-sage workflow"
403          if [ ! -d .git ]; then git init; fi; git remote add trac ${{ env.SAGE_TRAC_GIT }} && x=1 && while [ $x -le 5 ]; do x=$(( $x + 1 )); sleep $(( $RANDOM % 60 + 1 )); if git-trac-command/git-trac fetch $SAGE_TICKET; then git merge FETCH_HEAD || echo "(ignored)"; exit 0; fi; sleep 40; done; exit 1
404        if: env.SAGE_TRAC_GIT != ''
405      - uses: actions/download-artifact@v2
406        with:
407          path: upstream
408          name: upstream
409      - name: Update Sage packages from upstream artifact
410        run: |
411          (export PATH=$(pwd)/build/bin:$PATH; (cd upstream && bash -x update-pkgs.sh) && git diff)
412
413      - name: Install test prerequisites
414        run: |
415          brew install tox
416      - name: Build and test with tox
417        # We use a high parallelization on purpose in order to catch possible parallelization bugs in the build scripts.
418        # For doctesting, we use a lower parallelization to avoid timeouts.
419        run: |
420          MAKE="make -j12" tox -e $TOX_ENV -- SAGE_NUM_THREADS=4 $TARGETS
421      - name: Prepare logs artifact
422        run: |
423          mkdir -p "artifacts/$LOGS_ARTIFACT_NAME"; cp -r .tox/*/log "artifacts/$LOGS_ARTIFACT_NAME"
424        if: always()
425      - uses: actions/upload-artifact@v1
426        with:
427          path: artifacts
428          name: ${{ env.LOGS_ARTIFACT_NAME }}
429        if: always()
430      - name: Print out logs for immediate inspection
431        # and markup the output with GitHub Actions logging commands
432        run: |
433          .github/workflows/scan-logs.sh "artifacts/$LOGS_ARTIFACT_NAME"
434        if: always()
Note: See TracBrowser for help on using the repository browser.